// <pre>
// Sources for JeggLink1.2 by Perki (plegris@fbwww.epfl.ch)
// If you modify anything in this code please mail me about it
// I'll then upgrade JeggLink
// In this source code I removed the "password decoding method" 
// So if you compile this code don't use an encoded password in the html page

import java.applet.Applet;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

public class JeggLink extends Applet implements Runnable {
  // UI componements
  TextArea ChatArea = new TextArea(20 , 60);
  TextField ChatField = new TextField( 55 );
  List NickList = new List( 21 , false );
  TextField NickField = new TextField( 8 );
  static Font Def_Font = new Font("Helvetica", Font.PLAIN , 12);
  FontMetrics Def_FM = getFontMetrics(Def_Font);
  Canvas Top_Top = new titleC();
  private About myAbout;

  // Vars
  Socket s = null;
  DataInputStream sin;
  PrintStream sout;
  Thread myThread;
  String TopicT = "";
  static String TopicTT = "";
  String ligne;
  String nick = "www";
  boolean GotULI = false;
  boolean NoChNick = true;
  String host = "";
  int PORTI = 0;
  String Passwd = "";
  static Image titleI;

  // Start
  public void start() {
    if (myThread == null); {
      myThread = new Thread(this);
      myThread.start();
    }
  }
  
  // Stop
  public void stop() {
    sin = null;
    
    try {
      if (s != null) { 
	s.close() ; 
	s = null;
      }
    }
    catch (IOException e) { }
      
    if (myThread != null) { 
      myThread.stop();
      myThread = null;
    }
    destroy();
  }

  
  // Init
  public void init( ) {
    System.out.println("JeggLink Version 1.2  : Pierre-Mikael Legris \n http://fbwww.epfl.ch/~plegris/Jegg");
    titleI = getImage(getCodeBase(), "title.gif");
    makeUI( );
    // about setup
    Object frame = getParent();
    myAbout = new About((Frame) frame ,"About JeggLink");
    myAbout.hide() ;
    // about

    try {
      host = getCodeBase().getHost();
      PORTI = Integer.parseInt(getParameter("PORT"));
      Passwd = getParameter("PASSWD");
    } catch (Exception e) {System.err.println(e);}
        
    ChatArea.setText("   ########JeggLink By Perki ########## \n   #### Version 1.2 \n   #### Pierre-Mikael Legris  plegris@fbwww.epfl.ch \n\n");
    try {
      this.s = new Socket(host,PORTI);
      this.sout=new PrintStream(s.getOutputStream());
    } 
    catch (IOException e) {System.err.println(e);}
  }
  
  // User Interface
  public void makeUI( ) {
    setBackground(Color.white);
    setFont(Def_Font);
    NickList.setBackground(Color.white);
    ChatArea.setBackground(Color.white);
    ChatArea.setEditable( false );
    Panel S_P = new Panel();
     S_P.setLayout(new BorderLayout());
     S_P.add("Center" , ChatField);
     S_P.add("East" , NickField);
     
    Panel C_P = new Panel();
     C_P.setLayout(new BorderLayout());
     C_P.add("Center" , ChatArea);
     C_P.add("East" , NickList); 
     
    setLayout(new BorderLayout());
     add("Center" , C_P);
     add("South" , S_P);
     add("North" , Top_Top );

    repaint( );
  }// end MakeUI


  /// print method
  public void print(String p)
  {
    // word warping
    StringTokenizer st = new StringTokenizer(p);
    String tmp = "";
    String TToken = "";
    while (st.hasMoreTokens()) {
      TToken = st.nextToken();
      if (Def_FM.stringWidth(TToken) > 500 ) {
	TToken = tmp + " " + TToken;
	while (Def_FM.stringWidth(TToken) > 500) {
	  tmp = "";
	  int i;
	  for (i = 0; Def_FM.stringWidth(tmp) < 490 ; i++ )
	    tmp = tmp + TToken.substring(i  , i + 1);
	  TToken = TToken.substring(i , TToken.length());
	  ChatArea.appendText(tmp + "\n");
	}
	ChatArea.appendText(tmp + "\n");
	tmp = TToken;
      } else {
	if (Def_FM.stringWidth(tmp + " " + TToken) > 500 ) {
	  ChatArea.appendText(tmp + "\n" );
	  tmp = TToken;
	} else {
	  tmp = tmp + " " + TToken;
	}
      }
    }
    ChatArea.appendText(tmp + "\n");
	    
    // I use this to scroll down, and cut off
    int i = ChatArea.getText().length();
    if (i > 10000) {
      ChatArea.setText(ChatArea.getText().substring( i - 7000 , i));
      i = ChatArea.getText().length();
    }
    ChatArea.select(i,i);
    repaint();
  }// end print

  
  /// parse a string
  public void Parse_line(String l)
  {
    String tmp = "";
    String lt = "";
    String webp = "" ;
    StringTokenizer st = new StringTokenizer(l);
    if (st.hasMoreTokens()) 
      lt = st.nextToken();
    
    // est-ce un utilisateur web ?
    if (lt.compareTo("<www>") == 0)
      webp = "(web)" ;
    
    // detection de la sequence "***"
    while (st.hasMoreTokens() && (lt.compareTo("***") != 0))
      lt = st.nextToken();
    
    if (st.hasMoreTokens()) {
      lt = st.nextToken();
     
      
      // normal speach
      if ((lt.compareTo("SAY") == 0) && st.hasMoreTokens()) {
	lt = st.nextToken();
	if ((lt.compareTo(nick) == 0) && ( webp.compareTo("(web)") == 0)) {
	  tmp = ">";
	} else {
	  tmp = "<" + lt + webp + ">" ;
	}
	while (st.hasMoreTokens())
	  tmp = tmp + " " + st.nextToken() ;
	if(nick.compareTo("") != 0)
	    print(tmp + "\n");
      }
      
      // action on the channel
      if ((lt.compareTo("ACT") == 0) && st.hasMoreTokens()) {
	lt = st.nextToken();
	tmp = "*" + lt + webp  ;
	while (st.hasMoreTokens())
	  tmp = tmp + " " + st.nextToken() ;
	if(nick.compareTo("") != 0)
	    print(tmp + "\n");
      }
      
      // Users list
      if ((lt.compareTo("ULI") == 0) && st.hasMoreTokens()) {
	print(" ### RETRIEVING USER LIST ");
	NickList.addItem("Perki");
	NickList.clear();
	for (int i = 1 ; st.hasMoreTokens() ; i++)
	  NickList.addItem(st.nextToken());
	
	// if This is the first ULI set a default nickname
	if (! GotULI) {
	  int i;
	  for (i = 1 ;! Vnick("www" + i) ; i++)
	    print("\n ### Checking for nick www" + i);
	  nick = "www" + i;
	  sout.println(".wjoin " + nick + "(web) ");
	  print("### Your nick Is now " + nick );
	  print(" ### You can change it in the down - right text box ");
	  print(" ### Everything typed in the long text box will go to th channel \n");
	  GotULI = true;
	}
      }
      
      // Users Changes nick
      if ((lt.compareTo("NIC") == 0) && st.hasMoreTokens()) {
        NoChNick = false;
	String Nnick = "";
	String Onick = st.nextToken();
	if (st.hasMoreTokens())
	  Nnick = st.nextToken();
	if (Nnick != "") {
	  Parse_line("*** PAR " + Onick );
	  Parse_line("*** JOI " + Nnick );
	  print("*** " + Onick + " changed his nick to: " + Nnick + "\n" );
	}
        NoChNick = true;
      }

      // Users list join
      if ((lt.compareTo("JOI") == 0) && st.hasMoreTokens()) {
	String InetA = "";
	String Pnick = st.nextToken();
	if (st.hasMoreTokens())
	  InetA = st.nextToken();
	NickList.addItem(Pnick);
	if (NoChNick)
	  print("*** " + Pnick + " " + InetA + " joined the channel \n" );
      }

      // Topic is changing
      if ((lt.compareTo("TOP") == 0) && st.hasMoreTokens()) {
	tmp = "";
	TopicTT = "";
	while (st.hasMoreTokens())
	  tmp = tmp + " " + st.nextToken() ;
	TopicT = tmp;
	for (int i = 0; (i < TopicT.length()) && (Def_FM.stringWidth(TopicTT) < 490 ); i ++)
	  TopicTT = TopicT.substring(0,i);
	Top_Top.repaint();
	getAppletContext().showStatus(TopicT);
      }
      
      // A web user is kicked
      if ((lt.compareTo("WCK") == 0) && st.hasMoreTokens()) {
	String WGK = st.nextToken();
	tmp = "";
	while (st.hasMoreTokens())
	  tmp = tmp + " " + st.nextToken() ;
	String Lnick = new String(nick + "(web)");
	if (WGK.toLowerCase().compareTo(Lnick.toLowerCase()) == 0) { // Soo Bad It's you
	  print("You have been kicked by:" + tmp);
	  stop();
	} else {
	  print("" + WGK + "kicked by" +tmp);
	}
      }

      // Users list part
      if ((lt.compareTo("PAR") == 0) && st.hasMoreTokens()) {
	String Pnick = st.nextToken();
	if (NoChNick)
	  print("*** " + Pnick + " left the channel \n" );
	int NLs = NickList.countItems();
	for (int i = 0 ; i < NLs ; i++) {
	  String Anick = NickList.getItem(i);
	  if (Pnick.compareTo(Anick) == 0 )
	    {
	      NickList.delItem(i);
	      NLs = NickList.countItems();
	    }
	}
      }
      
    }
  }

  // Handle actions
  public boolean action(Event e, Object o)
  {
    // Dans le CHAT
    if(e.target == ChatField )
      {
        String In_text = ChatField.getText().trim();
        if(In_text.length()== 0 )
          return true;
	ChatField.setText("");
	//action ?
	if( In_text.length() > 5 ) {
	  String In_start = In_text.substring(0,5).toLowerCase();
	  // SI action (/ME)
	  if( In_start.regionMatches(0,"/me ",0,4)) {
	    sout.println(".wact " + nick + " " + In_text.substring(4,In_text.length()).replace('\"','\''));
	    return true;
	  }
	  // Si (/nick)
	  if( In_start.regionMatches(0,"/nick",0,5)) {
	    String In_nick = In_text.substring(6,In_text.length()).replace('\"','\'');
	    if(In_nick.length()== 0 )
	      return true;
	    NickField.setText(nick);
	    if (Vnick(In_nick))
	      sout.println(".wcnic " + nick + "(web) " );
	    return true;
	  }
	}
	// pas action ..
	sout.println("*** SAY " + nick + " " + In_text.replace('\"','\''));
	return true;
      }
    
    //Dans le NickField
    if(e.target == NickField )
      {
	String In_text = NickField.getText().trim();
	if(In_text.length()== 0 )
          return true;
	NickField.setText(nick);
	if (Vnick(In_text))
	  sout.println(".wcnic " + nick + "(web) " );
	return true;
      } 
    return true;
  } // END actions
  
  // Handle events
  public boolean handleEvent(Event evt)
  {
    if ((evt.target == NickList) && (evt.id == 701 )) {
      String whois =  NickList.getSelectedItem();
      if (whois != null ) 
	sout.println(".wwhois " + whois );
      return true;
      
    }
    if (evt.target == Top_Top) {
      if (evt.id == Event.MOUSE_ENTER)
	getAppletContext().showStatus("Click for informations about JeggLink");
      if (evt.id == Event.MOUSE_EXIT)
	getAppletContext().showStatus(TopicT);
      if (evt.id == 501) 
	myAbout.show();
      return true;
    }
     if (evt.id == Event.MOUSE_ENTER) {
      getAppletContext().showStatus(TopicT);
      return true;
    }
    return super.handleEvent(evt);
  }// events

  /// Verify the validity of a nickname
  boolean Vnick (String n) {
    if(n.length() > 8 ) {
      print("#Nick too Long ... 8 chars max\n");
      return false;
    } else {
      // Check if the nick isn't a double
      int NLs = this.NickList.countItems();
      for (int i = 0 ; i < NLs ; i++) {
	String Anick = this.NickList.getItem(i);
	if (Anick.compareTo(n + "(web)") == 0 )
	  {
	    if (GotULI)
	      print("#This nick already exists, please choose another \n");
	    return false;
	  }
      }
      this.nick = n.replace(' ','_');
      NickField.setText(this.nick);
      return true;
    }
  }// End Vnick


  /// Decode the Password 
 
  public String Decode(String In_text) {
    /* .....
       Here is normaly the decoding of the password
       .....
       */
    return In_text;
  }  
  // End Decode
  
  /// run
  public void run() {
    try {
      //print("Socket : " + s + "\n");
      sin = null;
      if (s != null) {
	sin = new DataInputStream(s.getInputStream());
      }
      if (sin == null) {
	print(" ### NOT CONNECTED ");
	print(" ### Press SHIFT and click RELOAD to connect");
	stop();
      } else {

      //print("Stream : " + sin + "\n");
      print("\n ### CONNECTING ");

      // entering the bot
      ligne = "";
      sout.println("www");
      while (! ligne.regionMatches(1,"Enter your",1,8))
	ligne=sin.readLine();
      sout.println(Decode(this.Passwd));
      sout.println(".chat 1");
      sout.println(".ulist");

      // reading the stream
      boolean more = true;
      while (more && (s != null) ) {
	  ligne=sin.readLine();
	if (ligne == "null") 	    
	  {
	    more = false;
	    print("ligne = null ");
	  }
	
	if (ligne != "") 	    
	  {
	    // print(ligne);
	      Parse_line(ligne);
	  }
	try{
	  Thread.sleep(100);
	}
	catch(InterruptedException e){System.err.println(e);}
      }
      }
    } // try  
    catch (IOException e) { System.err.println(e); }
    finally {
      try {
	if (s != null) { 
	  s.close() ; 
	  print("### DISCONECTED , Press SHIFT and click RELOAD to try again"); 
	}
      }
      catch (IOException e2) { System.err.println(e2) ; }
    }
  }
}

// Canvas that load the Title
class titleC extends Canvas {
  String textT = "";

  public void paint( Graphics titleg ){
    textT = JeggLink.TopicTT;
  
    titleg.drawImage(JeggLink.titleI,0,0, this);
    titleg.setFont(JeggLink.Def_Font);
    titleg.setColor(Color.white);
    titleg.drawString(textT,10,16);
  }
  public Dimension minimumSize() {
    return new Dimension(650,25);
  }
  public Dimension preferredSize() {
    return minimumSize();
  }
}// TitleC

// About Dialog box
class About extends Dialog
{
  private Button OK;
  private Frame thisFrame;
  
  About(Frame f, String title) {
    super(f, title, false); 
    thisFrame = f; 
    this.resize(300, 250); 
    OK = new Button("OK");
    
    Panel textP = new Panel();
    textP.setLayout(new GridLayout(6,1));
    textP.add(new Label("Jegglink V 1.2      1st feb 98",Label.CENTER));
    textP.add(new Label("By Pierre-Mikael Legris (Perki)",Label.CENTER));
    textP.add(new Label("plegris@fbwww.epfl.ch",Label.CENTER));
    textP.add(new Label(""));
    textP.add(new Label("JeggLink's Homepage:"));
    textP.add(new Label("http://fbwww.epfl.ch/~plegris/Jegg"));

    add("Center" , textP);
    add("South" , OK);
    repaint();
  }
  
  public boolean action(Event ev, Object obj) {
    if (ev.target == OK) {
      
      this.hide();
      this.dispose();
    }
    return true;
  }
}// About

















