import java.applet.Applet;
import java.awt.*;

public class JeggPass extends Applet {
  Label Header = new Label ("*** JeggPass ***",Label.CENTER);
  Label Passwd = new Label ("Password",Label.CENTER);
  Label Encode = new Label ("Encoded Pass",Label.CENTER);
  TextField Entry = new TextField( 8 );
  
  // Start
  public void start() {
    MakeUI();
  }

  public void MakeUI() {
    setBackground(Color.white);
    Header.setFont(new Font("Helvetica", Font.BOLD , 13));
    Header.setBackground(Color.blue);
    Header.setForeground(Color.white);
    Panel ctrl = new Panel();
    setLayout(new GridLayout(4,1));   
    add(Header);
    add(Passwd);
    add(Encode);
    add(Entry);
    repaint();
  }
  
  public char RetChar(int ValC) {
    boolean Majj = false;
    while (ValC > 61) { ValC = ValC - 62 ;}
    while (ValC < 0 ) { ValC = ValC + 62 ;}
    if (ValC > 35 ) {ValC = ValC - 26 ; Majj = true ;}
    char TChar = Character.forDigit(ValC, 36);
    if (Majj) { TChar = Character.toUpperCase(TChar);}
    return TChar;
  } 
  
  public String Decode(String In_text) {
    String tmp = ""; int Maj = 0; int Cval = 0; int Pas = -1; int Multi ; 
    char[] In_Char = In_text.toCharArray();
    if (Character.isUpperCase(In_Char[0])) { Maj = 26; } else { Maj = 0; }
    Multi = Character.digit(In_Char[0],36) + Maj -6;
    for (int i=1; i < 8 ; i++){
      if (Character.isUpperCase(In_Char[i])) { Maj = 26; } else { Maj = 0; }
      Cval = Character.digit(In_Char[i],36) + Maj ;
      if (Pas == 1) { Pas = -1 ;} else { Pas = 1 ;}
      Cval = Cval - (i + 2) * (Multi + 6) * Pas;
      tmp = tmp + RetChar(Cval);
    }
    tmp = tmp + RetChar(Multi);
    return tmp; 
  }

  public boolean action(Event e, Object o)
  {
    if(e.target == Entry )
      {
        String In_text = Entry.getText().trim();
        if(In_text.length() != 8 ) {
	  Encode.setText("Must be 8 chars long");
	  Passwd.setText("  The Password"); 
	  Entry.setText(""); 
	} else {
	  String tmp = "";
	  int Maj = 0;
	  int Cval = 0;
	  int Multi ;
	  int Pas = 1;
	  char[] In_Char = In_text.toCharArray();
	  if (Character.isUpperCase(In_Char[7])) { Maj = 26; } else { Maj = 0; }
	  Multi = Character.digit(In_Char[7],36) + Maj + 6;
	  tmp = "" + RetChar(Multi);
	  for (int i=0; i < 7 ; i++){
	    if (Character.isUpperCase(In_Char[i])) { Maj = 26; } else { Maj = 0; }
	    Cval = Character.digit(In_Char[i],36) + Maj ;
	    Cval = Cval + (i + 3) * Multi * Pas;
	    if (Pas == 1) { Pas = -1 ;} else { Pas = 1 ;}
	    tmp = tmp + RetChar(Cval);
	  }
	  Encode.setText(tmp);
	  Passwd.setText(Decode(tmp));
	}
	return true;
      } 
    return true;
  }
}




